blob: cbfb2462bb7619668b25f9be7ef3fe54782d5437 [file] [log] [blame]
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +00001#!/bin/bash
2
Damien Martin-Guillerezf88f4d82015-09-25 13:56:55 +00003# Copyright 2015 The Bazel Authors. All rights reserved.
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +00004#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Script for building bazel from scratch without bazel
18
Klaus Aehligf0099012016-09-28 12:13:17 +000019PROTO_FILES=$(ls src/main/protobuf/*.proto src/main/java/com/google/devtools/build/lib/buildeventstream/proto/*.proto)
Liam Miller-Cushonacd0d0c2016-12-08 05:26:45 +000020LIBRARY_JARS=$(find third_party -name '*.jar' | grep -Fv /javac-9-dev-r3297-1.jar | grep -Fv /javac7.jar | grep -Fv JavaBuilder | grep -ve third_party/grpc/grpc.*jar | tr "\n" " ")
dapengzhang03abcec12016-07-22 20:54:44 +000021GRPC_JAVA_VERSION=0.15.0
22GRPC_LIBRARY_JARS=$(find third_party/grpc -name '*.jar' | grep -e .*${GRPC_JAVA_VERSION}.*jar | tr "\n" " ")
23LIBRARY_JARS="${LIBRARY_JARS} ${GRPC_LIBRARY_JARS}"
Nathan Harmata8a475902016-11-23 19:08:12 +000024
25# tl;dr - error_prone_core contains a copy of an older version of guava, so we
26# need to make sure the newer version of guava always appears first on the
27# classpath.
28#
29# Please read the comment in third_party/BUILD for more details.
30LIBRARY_JARS_ARRAY=($LIBRARY_JARS)
31for i in $(seq 0 $((${#LIBRARY_JARS_ARRAY[@]} - 1)))
32do
Damien Martin-Guillerezb46631b2017-01-20 13:27:26 +000033 [[ "${LIBRARY_JARS_ARRAY[$i]}" =~ ^"third_party/error_prone/error_prone_core-".*\.jar$ ]] && ERROR_PRONE_INDEX=$i
34 [[ "${LIBRARY_JARS_ARRAY[$i]}" =~ ^"third_party/guava/guava-".*\.jar$ ]] && GUAVA_INDEX=$i
Nathan Harmata8a475902016-11-23 19:08:12 +000035done
36[ "${ERROR_PRONE_INDEX:+present}" = "present" ] || { echo "no error prone jar"; echo "${LIBRARY_JARS_ARRAY[@]}"; exit 1; }
37[ "${GUAVA_INDEX:+present}" = "present" ] || { echo "no guava jar"; exit 1; }
38if [ "$ERROR_PRONE_INDEX" -lt "$GUAVA_INDEX" ]; then
39 TEMP_FOR_SWAP="${LIBRARY_JARS_ARRAY[$ERROR_PRONE_INDEX]}"
40 LIBRARY_JARS_ARRAY[$ERROR_PRONE_INDEX]="${LIBRARY_JARS_ARRAY[$GUAVA_INDEX]}"
41 LIBRARY_JARS_ARRAY[$GUAVA_INDEX]="$TEMP_FOR_SWAP"
42 LIBRARY_JARS="${LIBRARY_JARS_ARRAY[@]}"
43fi
44
Damien Martin-Guillereze700e722016-06-30 15:06:39 +020045DIRS=$(echo src/{java_tools/singlejar/java/com/google/devtools/build/zip,main/java,tools/xcode-common/java/com/google/devtools/build/xcode/{common,util}} third_party/java/dd_plist/java ${OUTPUT_DIR}/src)
Lukacs Berki8b3b9182016-04-14 08:29:05 +000046EXCLUDE_FILES=src/main/java/com/google/devtools/build/lib/server/GrpcServerImpl.java
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000047
Alexander Chungfc071422017-02-07 12:48:26 +000048mkdir -p "${OUTPUT_DIR}/classes"
49mkdir -p "${OUTPUT_DIR}/src"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000050
51# May be passed in from outside.
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000052ZIPOPTS="$ZIPOPTS"
53
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000054unset JAVA_TOOL_OPTIONS
55unset _JAVA_OPTIONS
56
57LDFLAGS=${LDFLAGS:-""}
58
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000059MSYS_DLLS=""
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000060
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000061# Check that javac -version returns a upper version than $JAVA_VERSION.
Damien Martin-Guillerez338dc562015-06-23 17:15:12 +000062get_java_version
63[ ${JAVA_VERSION#*.} -le ${JAVAC_VERSION#*.} ] || \
64 fail "JDK version (${JAVAC_VERSION}) is lower than ${JAVA_VERSION}, please set \$JAVA_HOME."
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000065
66JAR="${JAVA_HOME}/bin/jar"
67
68# Compiles java classes.
69function java_compilation() {
70 local name=$1
71 local directories=$2
Lukacs Berkie21e5922016-04-12 12:22:20 +000072 local excludes=$3
73 local library_jars=$4
74 local output=$5
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000075
Laszlo Csomor54029932016-12-19 15:43:31 +000076 local classpath=${library_jars// /$PATHSEP}${PATHSEP}$5
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000077 local sourcepath=${directories// /$PATHSEP}
78
79 tempdir
80 local tmp="${NEW_TMPDIR}"
81 local paramfile="${tmp}/param"
Lukacs Berkie21e5922016-04-12 12:22:20 +000082 local filelist="${tmp}/filelist"
83 local excludefile="${tmp}/excludefile"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000084 touch $paramfile
85
86 mkdir -p "${output}/classes"
87
88 # Compile .java files (incl. generated ones) using javac
89 log "Compiling $name code..."
Lukacs Berkie21e5922016-04-12 12:22:20 +000090 find ${directories} -name "*.java" | sort > "$filelist"
91 # Quotes around $excludes intentionally omitted in the for statement so that
92 # it's split on spaces
93 (for i in $excludes; do
94 echo $i
95 done) | sort > "$excludefile"
96
97 comm -23 "$filelist" "$excludefile" > "$paramfile"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +000098
99 if [ ! -z "$BAZEL_DEBUG_JAVA_COMPILATION" ]; then
100 echo "directories=${directories}" >&2
101 echo "classpath=${classpath}" >&2
102 echo "sourcepath=${sourcepath}" >&2
103 echo "libraries=${library_jars}" >&2
104 echo "output=${output}/classes" >&2
105 echo "List of compiled files:" >&2
106 cat "$paramfile" >&2
107 fi
108
Julio Merino5909d9d2016-02-25 21:44:31 +0000109 run "${JAVAC}" -classpath "${classpath}" -sourcepath "${sourcepath}" \
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000110 -d "${output}/classes" -source "$JAVA_VERSION" -target "$JAVA_VERSION" \
Damien Martin-Guillerez45d18d42015-09-21 11:45:10 +0000111 -encoding UTF-8 "@${paramfile}"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000112
113 log "Extracting helper classes for $name..."
114 for f in ${library_jars} ; do
Julio Merino5909d9d2016-02-25 21:44:31 +0000115 run unzip -qn ${f} -d "${output}/classes"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000116 done
117}
118
119# Create the deploy JAR
120function create_deploy_jar() {
121 local name=$1
122 local mainClass=$2
123 local output=$3
124 shift 3
125 local packages=""
126 for i in $output/classes/*; do
127 local package=$(basename $i)
128 if [[ "$package" != "META-INF" ]]; then
129 packages="$packages -C $output/classes $package"
130 fi
131 done
132
133 log "Creating $name.jar..."
134 echo "Main-Class: $mainClass" > $output/MANIFEST.MF
Julio Merino5909d9d2016-02-25 21:44:31 +0000135 run "$JAR" cmf $output/MANIFEST.MF $output/$name.jar $packages "$@"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000136}
137
Klaus Aehlig967a0a32016-12-02 15:08:25 +0000138HOW_TO_BOOTSTRAP='
139
140--------------------------------------------------------------------------------
141NOTE: This failure is likely occuring if you are trying to bootstrap bazel from
142a developer checkout. Those checkouts do not include the generated output of
143the protoc compiler (as we prefer not to version generated files).
144
145* To build a developer version of bazel, do
146
147 bazel build //src:bazel
148
149* To bootstrap your first bazel binary, please download a dist archive from our
150 release page at https://github.com/bazelbuild/bazel/releases and run
151 compile.sh on the unpacked archive.
152
153The full install instructions to install a release version of bazel can be found
154at https://bazel.build/versions/master/docs/install.html#compiling-from-source
155For a rationale, why the bootstrap process is organized in this way, see
156https://bazel.build/designs/2016/10/11/distribution-artifact.html
157--------------------------------------------------------------------------------
158
159'
160
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000161if [ -z "${BAZEL_SKIP_JAVA_COMPILATION}" ]; then
Klaus Aehligd700dff52016-11-23 16:53:22 +0000162
163 if [ -d derived/src/java ]
164 then
165 log "Using pre-generated java proto files"
166 mkdir -p "${OUTPUT_DIR}/src"
167 cp -r derived/src/java/* "${OUTPUT_DIR}/src"
168 else
169
170 [ -n "${PROTOC}" ] \
Klaus Aehlig967a0a32016-12-02 15:08:25 +0000171 || fail "Must specify PROTOC if not bootstrapping from the distribution artifact${HOW_TO_BOOTSTRAP}"
Klaus Aehligd700dff52016-11-23 16:53:22 +0000172
173 [ -n "${GRPC_JAVA_PLUGIN}" ] \
Klaus Aehlig967a0a32016-12-02 15:08:25 +0000174 || fail "Must specify GRPC_JAVA_PLUGIN if not bootstrapping from the distribution artifact${HOW_TO_BOOTSTRAP}"
Klaus Aehligd700dff52016-11-23 16:53:22 +0000175
176 [[ -x "${PROTOC-}" ]] \
177 || fail "Protobuf compiler not found in ${PROTOC-}"
178
179 [[ -x "${GRPC_JAVA_PLUGIN-}" ]] \
180 || fail "gRPC Java plugin not found in ${GRPC_JAVA_PLUGIN-}"
181
182 log "Compiling Java stubs for protocol buffers..."
183 for f in $PROTO_FILES ; do
184 run "${PROTOC}" -Isrc/main/protobuf/ \
185 -Isrc/main/java/com/google/devtools/build/lib/buildeventstream/proto/ \
186 --java_out=${OUTPUT_DIR}/src \
187 --plugin=protoc-gen-grpc="${GRPC_JAVA_PLUGIN-}" \
188 --grpc_out=${OUTPUT_DIR}/src "$f"
189 done
190 fi
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000191
Lukacs Berkie21e5922016-04-12 12:22:20 +0000192 java_compilation "Bazel Java" "$DIRS" "$EXCLUDE_FILES" "$LIBRARY_JARS" "${OUTPUT_DIR}"
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000193
194 # help files: all non java and BUILD files in src/main/java.
195 for i in $(find src/main/java -type f -a \! -name '*.java' -a \! -name 'BUILD' | sed 's|src/main/java/||'); do
196 mkdir -p $(dirname ${OUTPUT_DIR}/classes/$i)
197 cp src/main/java/$i ${OUTPUT_DIR}/classes/$i
198 done
199
Damien Martin-Guillerez12c68aa2016-01-15 13:18:11 +0000200 # Overwrite tools.WORKSPACE, this is only for the bootstrap binary
Klaus Aehlig286cfdd2016-10-17 16:47:55 +0000201 chmod u+w "${OUTPUT_DIR}/classes/com/google/devtools/build/lib/bazel/rules/tools.WORKSPACE"
Damien Martin-Guillerezbe5b2eb2016-03-02 16:08:07 +0000202 cat <<EOF >${OUTPUT_DIR}/classes/com/google/devtools/build/lib/bazel/rules/tools.WORKSPACE
203local_repository(name = 'bazel_tools', path = __workspace_dir__)
204bind(name = "cc_toolchain", actual = "@bazel_tools//tools/cpp:default-toolchain")
205EOF
Damien Martin-Guillerez12c68aa2016-01-15 13:18:11 +0000206
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000207 create_deploy_jar "libblaze" "com.google.devtools.build.lib.bazel.BazelMain" \
Han-Wen Nienhuysa4b61822015-11-09 13:55:44 +0000208 ${OUTPUT_DIR}
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000209fi
210
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000211log "Creating Bazel install base..."
212ARCHIVE_DIR=${OUTPUT_DIR}/archive
213mkdir -p ${ARCHIVE_DIR}/_embedded_binaries
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000214
Damien Martin-Guillerezdceee0e2016-01-18 11:57:26 +0000215# Dummy build-runfiles
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000216cat <<'EOF' >${ARCHIVE_DIR}/_embedded_binaries/build-runfiles${EXE_EXT}
Klaus Aehlig6992e682016-08-05 12:27:21 +0000217#!/bin/sh
Lukacs Berki25f35692016-08-04 10:38:36 +0000218mkdir -p $2
Damien Martin-Guillerezdceee0e2016-01-18 11:57:26 +0000219cp $1 $2/MANIFEST
220EOF
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000221chmod 0755 ${ARCHIVE_DIR}/_embedded_binaries/build-runfiles${EXE_EXT}
Damien Martin-Guillerezd47a8ef2015-06-10 11:54:50 +0000222
Damien Martin-Guillerez8c04e9e2016-01-18 12:53:39 +0000223log "Creating process-wrapper..."
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000224cat <<'EOF' >${ARCHIVE_DIR}/_embedded_binaries/process-wrapper${EXE_EXT}
Klaus Aehlig6dbcc2d2016-05-11 12:46:42 +0000225#!/bin/sh
Damien Martin-Guillerezec758db2016-01-18 12:14:28 +0000226# Dummy process wrapper, does not support timeout
227shift 2
Dmitry Lomov9bf3f6a2016-07-07 13:50:06 +0000228stdout="$1"
229stderr="$2"
230shift 2
231
232if [ "$stdout" = "-" ]
233then
234 if [ "$stderr" = "-" ]
235 then
236 "$@"
237 exit $?
238 else
239 "$@" 2>"$stderr"
240 exit $?
241 fi
242else
243 if [ "$stderr" = "-" ]
244 then
245 "$@" >"$stdout"
246 exit $?
247 else
248 "$@" 2>"$stderr" >"$stdout"
249 exit $?
250 fi
251fi
252
Klaus Aehligb2973412016-03-16 13:55:40 +0000253
254"$@"
Damien Martin-Guillerezec758db2016-01-18 12:14:28 +0000255exit $?
256EOF
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000257chmod 0755 ${ARCHIVE_DIR}/_embedded_binaries/process-wrapper${EXE_EXT}
Philipp Wollermann43c4a1a2015-08-25 12:52:57 +0000258
Laszlo Csomord40c78a2016-12-20 10:22:17 +0000259function build_jni() {
260 local -r output_dir=$1
261
262 case "${PLATFORM}" in
263 msys*|mingw*)
264 # We need JNI on Windows because some filesystem operations are not (and
265 # cannot be) implemented in native Java.
266 log "Building Windows JNI library..."
267
268 local -r jni_lib_name="windows_jni.dll"
269 local -r output="${output_dir}/${jni_lib_name}"
270 local -r tmp_output="${NEW_TMPDIR}/jni/${jni_lib_name}"
271 mkdir -p "$(dirname "$tmp_output")"
272 mkdir -p "$(dirname "$output")"
273
274 # Keep this `find` command in sync with the `srcs` of
275 # //src/main/native:windows_jni
276 local srcs=$(find src/main/native \
277 -name 'windows_*.cc' -o -name 'windows_*.h')
278 [ -n "$srcs" ] || fail "Could not find sources for Windows JNI library"
279
280 # do not quote $srcs because we need to expand it to multiple args
281 src/main/native/build_windows_jni.sh "$tmp_output" ${srcs}
282
283 cp "$tmp_output" "$output"
284 chmod 0555 "$output"
285
286 JNI_FLAGS="-Dio.bazel.EnableJni=1 -Djava.library.path=${output_dir}"
287 ;;
288
289 *)
290 # We don't need JNI on other platforms.
291 JNI_FLAGS="-Dio.bazel.EnableJni=0"
292 ;;
293 esac
294}
295
296build_jni "${ARCHIVE_DIR}/_embedded_binaries"
297
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000298cp src/main/tools/build_interface_so ${ARCHIVE_DIR}/_embedded_binaries/build_interface_so
299cp src/main/tools/jdk.BUILD ${ARCHIVE_DIR}/_embedded_binaries/jdk.BUILD
300cp $OUTPUT_DIR/libblaze.jar ${ARCHIVE_DIR}
Chris Parsons381850e2016-08-31 17:04:17 +0000301
302# TODO(b/28965185): Remove when xcode-locator is no longer required in embedded_binaries.
303log "Compiling xcode-locator..."
304if [[ $PLATFORM == "darwin" ]]; then
305 run /usr/bin/xcrun clang -fobjc-arc -framework CoreServices -framework Foundation -o ${ARCHIVE_DIR}/_embedded_binaries/xcode-locator tools/osx/xcode_locator.m
306else
307 cp tools/osx/xcode_locator_stub.sh ${ARCHIVE_DIR}/_embedded_binaries/xcode-locator
308fi
Chris Parsonsf4888182016-01-08 00:42:14 +0000309
Laszlo Csomor9f7180f2016-09-27 13:07:43 +0000310function run_bazel_jar() {
311 local command=$1
312 shift
Dmitry Lomovf9f2e102016-01-29 14:26:46 +0000313 "${JAVA_HOME}/bin/java" \
Philipp Wollermann74cb8c72016-07-15 14:01:37 +0000314 -XX:+HeapDumpOnOutOfMemoryError -Xverify:none -Dfile.encoding=ISO-8859-1 \
Carmi Grushko4068a1d2016-06-22 18:43:13 +0000315 -XX:HeapDumpPath=${OUTPUT_DIR} \
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000316 -Djava.util.logging.config.file=${OUTPUT_DIR}/javalog.properties \
Laszlo Csomord40c78a2016-12-20 10:22:17 +0000317 ${JNI_FLAGS} \
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000318 -jar ${ARCHIVE_DIR}/libblaze.jar \
319 --batch \
320 --install_base=${ARCHIVE_DIR} \
321 --output_base=${OUTPUT_DIR}/out \
322 --install_md5= \
323 --workspace_directory=${PWD} \
Kristina Chodorow4873e562016-06-20 14:17:50 +0000324 --nofatal_event_bus_exceptions \
Klaus Aehlig276a8cd2016-07-11 12:06:07 +0000325 ${BAZEL_DIR_STARTUP_OPTIONS} \
Laszlo Csomor50f6bba2016-09-26 14:10:25 +0000326 ${BAZEL_BOOTSTRAP_STARTUP_OPTIONS:-} \
Laszlo Csomor9f7180f2016-09-27 13:07:43 +0000327 $command \
Damien Martin-Guillerez51a204a2016-02-08 14:59:59 +0000328 --ignore_unsupported_sandboxing \
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000329 --startup_time=329 --extract_data_time=523 \
Klaus Aehlig7038d3f2016-03-16 15:41:22 +0000330 --rc_source=/dev/null --isatty=1 \
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000331 --ignore_client_env \
332 --client_cwd=${PWD} \
Damien Martin-Guillerezdaffc352016-01-18 15:20:32 +0000333 "${@}"
334}